HDU

来源:互联网 发布:手机网络无法登陆钉钉 编辑:程序博客网 时间:2024/06/02 04:31

Proud Merchants

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/65536 K (Java/Others)
Total Submission(s): 7161    Accepted Submission(s): 2973


Problem Description
Recently, iSea went to an ancient country. For such a long time, it was the most wealthy and powerful kingdom in the world. As a result, the people in this country are still very proud even if their nation hasn’t been so wealthy any more.
The merchants were the most typical, each of them only sold exactly one item, the price was Pi, but they would refuse to make a trade with you if your money were less than Qi, and iSea evaluated every item a value Vi.
If he had M units of money, what’s the maximum value iSea could get?

 

Input
There are several test cases in the input.

Each test case begin with two integers N, M (1 ≤ N ≤ 500, 1 ≤ M ≤ 5000), indicating the items’ number and the initial money.
Then N lines follow, each line contains three numbers Pi, Qi and Vi (1 ≤ Pi ≤ Qi ≤ 100, 1 ≤ Vi ≤ 1000), their meaning is in the description.

The input terminates by end of file marker.

 

Output
For each test case, output one integer, indicating maximum value iSea could get.

 

Sample Input
2 1010 15 105 10 53 105 10 53 5 62 7 3
 

Sample Output
511
 

Author
iSea @ WHU
 

Source
2010 ACM-ICPC Multi-University Training Contest(3)——Host by WHU 
 


题意:有n件物品,每件物品有pi,qi,vi三个属性,分别代表的是购买该物品的花费,购买时至少需要持有的钱 以及该物品的价值



q属性的加入导致了要考虑购买时要考虑购买的先后顺序

设有物品A(p1,q1,v1)与物品B(p2,q2,v2),若先购买A再购买B则至少需要(p1+q2)的钱(q1≤p1+q2),若先购买B则至少需要(p2+q1)的钱(q2≤p2+q1)

哪种至少花的钱少就选哪种,如(p1+q2)<(p2+q1)时就先买物品A,可以得到此时 q1 - p1 > q2 - p2

所以按差值大的先买,dp的过程是个逆过程,所以排序时要按差值小的来


#include<iostream>#include<string.h>#include<stdio.h>#include<algorithm>using namespace std;#define LL long longLL n,m,dp[5050];struct node{LL p,q,v;}a[505];bool cmp(node a,node b){    return (a.q-a.p)<(b.q-b.p);}int main(){    while(~scanf("%lld%lld",&n,&m)){        for(int i=0;i<n;i++){            scanf("%lld%lld%lld",&a[i].p,&a[i].q,&a[i].v);        }        memset(dp,0,sizeof dp);        sort(a,a+n,cmp);        for(int i=0;i<n;i++){            for(LL j=m;j>=a[i].q;j--){                dp[j] = max(dp[j],dp[j-a[i].p] + a[i].v);            }        }        printf("%lld\n",dp[m]);    }    return 0;}



原创粉丝点击